var currentLevel = -1;
var correctAnswer = "";
var selectedAnswer = "";
var GameQuestions = new Array();

function updateProgress(){
 for(var z=0; z < 6; z++){
  var d = document.getElementById("p"+z);
  d.style.background = "";
  if(z == currentLevel)
  d.style.background = "url(dot.png) left center no-repeat";
 }
}

function readQuestions(){
 GameQuestions = new Array();
 for(var z=1; z < 7; z++){
  GameQuestions.push(new Array());
  for(var i=0; i < 20; i++){
   var o = new Object();
   o.question = AppClient.getParameter("level"+z+"_q"+i);
   o.answer1  = AppClient.getParameter("level"+z+"_a"+i+"_1");
   o.answer2  = AppClient.getParameter("level"+z+"_a"+i+"_2");
   o.answer3  = AppClient.getParameter("level"+z+"_a"+i+"_3");
   o.answer4  = AppClient.getParameter("level"+z+"_a"+i+"_4");
   if(trim(o.question) === "") continue; 
   if(trim(o.answer1) === "") continue; 
   if(trim(o.answer2) === "") continue; 
   if(trim(o.answer3) === "") continue; 
   if(trim(o.answer4) === "") continue; 
   // only add complete questions with 4 answer options
   GameQuestions[z-1].push(o);
  }
 }
}

function gameEndNoMoreQuestions(){
 var d = document.getElementById("finishPanel");
 d.style.display = "block";

 var s = AppClient.getParameter("feedback");
 s = s.replace(/\r/g,"");
 s = s.replace(/\n/g,"<br>");
 if(s == "") s = AppClient.getTranslation("FeedbackValue");
 AppClient.setSolved();

 var d = document.getElementById("niceText");
 d.innerHTML = AppClient.linkifyText(s);

}

function gameEndWrongAnswer(){
 var d = document.getElementById("wrongAnswerPanel");
 d.style.display = "block";
}

function restartGame(){
 var d = document.getElementById("wrongAnswerPanel");
 d.style.display = "none";
 var d = document.getElementById("finishPanel");
 d.style.display = "none";
 currentLevel = -1;
 getNextQuestion();
}

function getNextQuestion(){
 var d = document.getElementById("progressPanel");
 d.style.display = "block";
 var d = document.getElementById("questionPanel");
 d.style.display = "none";

 currentLevel++; 
 updateProgress();

 if(currentLevel > 5) {gameEndNoMoreQuestions(); return; }
 var a = GameQuestions[currentLevel];
 if(a.length == 0){
  setTimeout(getNextQuestion,500);
  return;
 }

 var n = Math.floor(Math.random()*a.length);
 var o = a[n];
 setQuestion(o.question,o.answer1,o.answer2,o.answer3,o.answer4);

 setTimeout(function(){ 
  var d = document.getElementById("progressPanel");
  d.style.display = "none";
  var d = document.getElementById("questionPanel");
  d.style.display = "table-cell";
  rescaleFontSize();
 },2000);
}

function blink(id,color){
 var d = document.getElementById(id);
 var org = d.style.backgroundColor;
 d.style.backgroundColor = color;
 setTimeout(function(){d.style.backgroundColor = org;},100);
 setTimeout(function(){d.style.backgroundColor = color;},200);
 setTimeout(function(){d.style.backgroundColor = org;},300);
 setTimeout(function(){d.style.backgroundColor = color;},400);
}

function selectAnswer(e){
 if(selectedAnswer !== "") return;
 selectedAnswer = e.id;
 if(e.id == correctAnswer){
  blink(e.id,"#86da33");
  setTimeout(getNextQuestion,2000);
 }else{
  e.style.backgroundColor = "#da5733";
  blink(correctAnswer,"#86da33");
  setTimeout(gameEndWrongAnswer,3000);
 }
}

function setQuestion(frage,a1,a2,a3,a4){
 selectedAnswer = "";
 var d = document.getElementById("frage");
 d.innerHTML = frage;
 var list = new Array();
 list.push(a1);
 list.push(a2);
 list.push(a3);
 list.push(a4);
 list = AppClient.shuffleArray(list); 

 for(var i=0; i < list.length; i++){
  var d = document.getElementById("antwortText"+(i+1)); 
  d.innerHTML = list[i];

  if(list[i] == a1) correctAnswer = "antwort"+(i+1);
  var d = document.getElementById("antwort"+(i+1));
  d.style.backgroundColor = "";
  d.onmouseover = function(){this.style.backgroundColor = "rgba(140, 120, 255, 0.9)";}; 
  d.onmouseout = function(){this.style.backgroundColor = "";}; 
 }
}

function rescaleFontSize(){
 var w = $(window).width();
 var h = $(window).height();
 var m = Math.max(h,w);
 $("#scrollPanel").css({"font-size":Math.round(m/70)+"px"}); 
 var antwortHeight = Math.round(Math.min(w/5,h/5));
 antwortHeight = Math.max(antwortHeight,$(".antwortLabel").height());
 $(".antwort").css("height",antwortHeight+"px");
 var changed = false;
 // after resize refit attached cards again 
 $(".antwortText, .frageText").each(function(){
   // resize card font size: 
   var resizeText = $(this);
   var fontSize = 2.2;
   var old = resizeText.css('font-size'); 
   resizeText.css('font-size', fontSize+"em");
   resizeText.css('line-height', "normal");
   var textHeight,lastH;
   var textWidth,lastW;
   fontSize = 2.0;
   do {
        resizeText.css('font-size', fontSize+"em");
        textHeight = parseInt(resizeText.height());
        textWidth = parseInt(resizeText.width());
        if(lastW == textWidth && lastH == textHeight) break; // same size
        if(resizeText.hasClass("frageText") && textHeight <= antwortHeight) break;
        lastW = textWidth;
        lastH = textHeight;
        fontSize = fontSize - 0.1;
   } while (fontSize > 0.3);
   changed = changed || resizeText.css('font-size') != old; 
 });
 if(changed) setTimeout(rescaleFontSize ,100);
}

AppClient.onInit = function(){
 var d = document.getElementById("badText");
 d.innerHTML = AppClient.getTranslation("badText");
 var d = document.getElementById("restartButton");
 d.innerHTML = AppClient.getTranslation("restartButton");
 var d = document.getElementById("niceText");
 d.innerHTML = AppClient.getTranslation("niceText");
 var d = document.getElementById("endButton");
 d.innerHTML = AppClient.getTranslation("endButton");

 readQuestions();
 restartGame();
 $(window).on('resize', rescaleFontSize);
};